;SSE3 READ LDDQU
BITS 32

extern _StartTime
extern _EndTime
extern _ElapsedTime

SECTION .text
global	_read_LDDQU

_read_LDDQU:
	push	ebx
	push	esi
	push	edi
	mov	edi, [esp+20]
	dec	edi
	cpuid
	rdtsc
	mov	[_StartTime+4], edx
	mov	[_StartTime], eax
	mov	ecx, [esp+24]
	xor	eax, eax
	test	ecx, ecx
	jle	SHORT $L74418
$L74416:
	test	eax, edi
	jne	SHORT $L74419
	mov	esi, [esp+16]
$L74419:
	lddqu	xmm0, [esi]
	lddqu	xmm1, [esi+16]
	lddqu	xmm2, [esi+32]
	lddqu	xmm3, [esi+48]
	lddqu	xmm4, [esi+64]
	lddqu	xmm5, [esi+80]
	lddqu	xmm6, [esi+96]
	lddqu	xmm7, [esi+112]
	add	esi, 128				; 00000080H
	inc	eax
	cmp	eax, ecx
	jl	SHORT $L74416
$L74418:
	cpuid
	rdtsc
	mov	[_EndTime+4], edx
	mov	[_EndTime], eax
	mov	esi, [_StartTime]
	mov	eax, [_EndTime]
	mov	ecx, [_EndTime+4]
	mov	edx, [_StartTime+4]
	sub	eax, esi
	pop	edi
	sbb	ecx, edx
	pop	esi
	mov	[_ElapsedTime], eax
	mov	[_ElapsedTime+4], ecx
	pop	ebx
	ret	

